.include "m162def.inc"
 
.def temp	= R16

.dseg	;Data segment
.org 0x0100

vert:	.byte 1		; 0 - 15  (0-top)
gor:	.byte 1		; 0 - 9   (0-left)


.cseg
.org 0x00
		rjmp start

start:	cli
 		ldi temp,LOW(RAMEND)		;Init Stack Pointer
        out spl,temp
        ldi temp,HIGH(RAMEND)
        out sph,temp
		
		call lcdinit

		rcall black

		ldi temp, 0
m1:		rcall hx
		inc temp
		cpi temp, 126
		brne m1

loop:	rjmp loop


hx:		; print byte in Hex format
		push temp
		push r19
		ldi r19, 0
		call sim
		swap temp
		ldi r19, 8
		call sim
		lds r19, vert
		lds temp, gor
		inc temp
		cpi temp, 9
		brne sim7
		ldi temp, 0
		inc r19
		cpi r19, 14
		brne sim7
		ldi r19,0
sim7:	sts gor, temp
		sts vert, r19
		pop r19
		pop temp
		ret
sim:
		push temp
		push ZH		; r31
		push ZL		; r30
		push r17	; vert
		push r18	; gor
		push r20
		push r21
		push r22
		lds r17, vert
		lds r18, gor
		ldi ZH, high(FONT<<1)
		ldi ZL, low(FONT<<1)
		andi temp, 0xF0
		lsr temp
		adc ZL, temp
		ldi temp, 0
		adc ZH, temp
		ldi temp, 16
		sub temp, r17
		lsl temp
		lsl temp
		lsl temp
		dec temp
		sub temp, r17
		mov r17, temp	; vert in picsel
		mov temp, r18
		swap temp
		add temp, r18
		add temp, r18
		add r18, temp
		ldi temp, 4
		add r18, temp		; gor in picsel
		add r18, r19
		ldi     r20, 8	; stroki
sim3:	lpm temp, Z+
		ldi r21, 8		; stolbcy
sim2:	sbrs temp, 07
		rjmp sim1
		ldi r22, 0xFF
		rcall point
		rjmp sim8
sim1:	ldi r22, 0
		rcall point
sim8:	lsl temp
		inc r18
		dec r21
		brne sim2
		dec r17
		ldi temp, 8
		sub r18, temp
		dec r20
		brne sim3
		pop r22
		pop r21
		pop r20
		pop r18
		pop r17
		pop ZL
		pop ZH
		pop temp
		ret

point:						; temp, r17 vert 0 - 131, r18 gor 0 - 175
		push temp
		ldi temp, 0xEF
    	rcall lcd_wrcmd
		ldi temp, 0x90
    	rcall lcd_wrcmd
		ldi temp, 0x05
    	rcall lcd_wrcmd
		ldi temp, 0x00
    	rcall lcd_wrcmd
		ldi temp, 0x06
    	rcall lcd_wrcmd
		mov temp, r17
    	rcall lcd_wrcmd
		ldi temp, 0x07
    	rcall lcd_wrcmd
		mov temp, r18
    	rcall lcd_wrcmd
		mov	temp, r22		; color point
		rcall lcd_wrdata
		mov	temp, r22		; color point
		rcall lcd_wrdata
		pop temp
		ret

black:						; black screen
		push    r30
		push    r31
		ldi temp, 0
		sts gor, temp
		sts vert, temp
		ldi     r31, 0xB5
		ldi     r30, 0x80
		ldi     temp, 0x00
black1:	rcall   lcd_wrdata
		sbiw    r30,1
		brne    black1
		pop r31
		pop r30
		ret

delay:	ldi	temp, 0xFF		; 1541*255 (~ 0.1 c by 4MHZ)
delay2:	rcall delay1
		dec temp
		brne delay2
		ret
delay1:	push temp
		ldi  temp, 0xFF			; 6*255+11=1541 (~ 0.4 mc by 4MHZ)
delay0:	dec  temp
		nop
		nop
		nop
		brne delay0
		pop temp
		ret

lcd_wrcmd:
    cbi     PORTB,LCD_CS    ;select Display
		sbi PORTB,LCD_RS    ; set RS line
		rjmp SPI_SEND
lcd_wrdata:
    cbi     PORTB,LCD_CS    ;select Display
    cbi     PORTB,LCD_RS    ; clear RS line
SPI_SEND:   
    sbi SPCR,SPE        ;enable SPI
    out SPDR,temp        ;load byte in SPI data register
SPI_SEND_0: 
    sbis    SPSR,SPIF
    rjmp    SPI_SEND_0      ;transmitt byte to LCD
    in  r0,SPDR
	sbi PORTB,LCD_CS        ;deselect Display
    ret
 
lcdinit:

.equ LCD_RESET	= 0	; RESET
.equ LCD_RS		= 1 ; RS
.equ LCD_CS		= 4 ; CS
.equ LCD_MOSI	= 5 ; DAT
.equ LCD_MISO	= 6 ; (not used)
.equ LCD_SCK	= 7 ; CLK

		cbi     PORTB,	LCD_RESET	; display reset (0)
    	sbi     DDRB,	LCD_RESET	; set reset as output
    	sbi     DDRB,	LCD_MOSI	; MOSI must be set as output for SPI (dat)
    	cbi     PORTB,	LCD_CS		; select display (0)
    	sbi     DDRB,	LCD_CS		; CS must be output for Master mode to work
    	cbi     PORTB,	LCD_SCK		; set SCK lo (CLK) (0)
    	sbi     DDRB,	LCD_SCK		; set SCK as output
    	sbi     PORTB,	LCD_MISO	; enable pull up of MISO to avoid floating input
    	sbi     PORTB,	LCD_RS		; start with RS=high (1)
    	sbi     DDRB,	LCD_RS		; RS signal is output
 
		ldi temp,(1<<MSTR) | (1<<SPE)
		out SPCR,temp
 		ldi temp,1				; double speed bit
		out SPSR,temp

		cbi PORTB, LCD_RESET	; release reset (0)
		rcall delay
		sbi PORTB, LCD_RESET	; release reset (1)
		in temp,SPSR			; clear status

    	ldi ZH, high(INIT<<1)
		ldi ZL, low(INIT<<1)
		ldi     r17, 81			; number of bytes to be transmitted
wrtab:	lpm temp, Z+
		cpi temp, 0xFF
		brne init1
		rcall delay
		rjmp wrtab
init1:	rcall lcd_wrcmd
		dec r17
		brne    wrtab
		ret

INIT:  ; 81 bytes
.db 0xFF, 0xFD, 0xFD, 0xFD, 0xFD, 0xFF
.db 0xEF, 0x00, 0xEE, 0x04, 0x1B, 0x04, 0xFE, 0xFE, 0xFE, 0xFE, 0xEF, 0x90, 0x4A, 0x04
.db 0x7F, 0x3F, 0xEE, 0x04, 0x43, 0x06, 0xFF, 0xFF
.db 0xEF, 0x90, 0x09, 0x83, 0x08, 0x00, 0x0B, 0xAF, 0x0A, 0x00, 0x05, 0x00, 0x06, 0x00
.db 0x07, 0x00, 0xEF, 0x00, 0xEE, 0x0C, 0xEF, 0x90, 0x00, 0x80, 0xEF, 0xB0, 0x49, 0x02 
.db 0xEF, 0x00, 0x7F, 0x01, 0xE1, 0x81, 0xE2, 0x02, 0xE2, 0x76, 0xE1, 0x83
.db 0xFF, 0xE2, 0x02, 0xE2, 0x76, 0xE1, 0x83, 0x80, 0x01, 0xFF
.db 0xEF, 0x90, 0x00, 0x00

FONT:
.db 0x3E,0x63,0x63,0x6B,0x63,0x63,0x3E,0x00 ; 0
.db 0x18,0x38,0x58,0x18,0x18,0x18,0x7E,0x00 ; 1
.db 0x3C,0x66,0x06,0x1C,0x30,0x66,0x7E,0x00
.db 0x3C,0x66,0x06,0x1C,0x06,0x66,0x3C,0x00
.db 0x0E,0x1E,0x36,0x66,0x7F,0x06,0x0F,0x00
.db 0x7E,0x60,0x7C,0x06,0x06,0x66,0x3C,0x00
.db 0x1C,0x30,0x60,0x7C,0x66,0x66,0x3C,0x00
.db 0x7E,0x66,0x06,0x0C,0x18,0x18,0x18,0x00
.db 0x3C,0x66,0x66,0x3C,0x66,0x66,0x3C,0x00
.db 0x3C,0x66,0x66,0x3E,0x06,0x0C,0x38,0x00
.db 0x18,0x3C,0x66,0x66,0x7E,0x66,0x66,0x00
.db 0x7E,0x33,0x33,0x3E,0x33,0x33,0x7E,0x00
.db 0x1E,0x33,0x60,0x60,0x60,0x33,0x1E,0x00
.db 0x7C,0x36,0x33,0x33,0x33,0x36,0x7C,0x00
.db 0x7F,0x31,0x34,0x3C,0x34,0x31,0x7F,0x00 ; E
.db 0x7F,0x31,0x34,0x3C,0x34,0x30,0x78,0x00 ; F
